/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.guosen.bussiness.service;

import org.springblade.core.tool.api.R;
import org.springblade.modules.guosen.bussiness.entity.Bussiness;
import org.springblade.modules.guosen.bussiness.vo.BussinessVO;
import org.springblade.core.mp.base.BaseService;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.yeePay.entity.PayOrderDto;

import java.math.BigDecimal;
import java.util.List;

/**
 *  服务类
 *
 * @author BladeX
 * @since 2021-07-08
 */
public interface IBussinessService extends BaseService<Bussiness> {

	/**
	 * 自定义分页
	 *
	 * @param page
	 * @param bussiness
	 * @return
	 */
	IPage<Bussiness> selectBussinessPage(IPage<Bussiness> page, BussinessVO bussiness);

	boolean saveOrUpdate(Bussiness bussiness);

	String generateApiByBussiness(Bussiness bussiness);

    boolean updateRemain(Bussiness bussiness);

    boolean updateFreeze(Bussiness bussiness);

	boolean updateRemainFreeze(Bussiness bussiness);

	boolean enable(Long bussinessId, Integer enable);

	R<BigDecimal> queryBalance(String merchantNo);

	R deleteBussiness(String ids);

	Bussiness getByMerchantNo(String merchantNo);

	/**
	 * 体验商户新增或修改
	 * @param bussiness
	 * @return
	 */
	boolean testSaveOrUpdate(Bussiness bussiness);

	List<Bussiness> getByBussinessType(Integer bussinessType);

}
